<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
    <style>
        /* .router-link-active { */
        .router-link-exact-active {
            background-color: green;
        }
    </style>
</head>
<body>
    <div id="app">
        <app></app>
    </div>

    <script src="https://unpkg.com/vue@2.6.10/dist/vue.js"></script>
    <script src="https://unpkg.com/vue-router@3.0.2/dist/vue-router.js"></script>
    <script>
    const home = Vue.component('Home', { 
        template: `<div>
                    <header>home</header>
                    <main>main area home</main>
                    <footer>...</footer>
                    </div>`
    });
    const about = Vue.component('About', { 
        methods: {
            navigateToHome() {
                // navigation programmatique
                // this.$router.push('/');  // via path
                this.$router.push({name:'home'}); // via route nommée
                // this.$router.push({name:'product-by-id', params: {id: 1} }); // via route nommée
            }
        },
        template: `<div>
            <header>about</header>
            <main>
                main area about
                <button @click="navigateToHome">go to homepage</button>
                </main>
            <footer><router-link to="/">accueil</router-link></footer>
            </div>`
        });
    const NotFound = Vue.component('NotFound', { template: `<div>page not found</div>`});

    const product = Vue.component('Product', { template: `<div>produit d'id {{ $route.params.id }}</div>`});

    const router = new VueRouter({
        routes: [
            { path: '/', name:'home', component: home},
            { path: '/product/:id', name:'product-by-id', component: product},
            { path: '/page-about', name:'about', component: about},
            { path: '*', name: 'notfound', component: NotFound} 
        ]
    })

    Vue.component('app', {
        template:`
        <div>
            <router-link to="/">accueil</router-link>
            <router-link :to="{name: 'product-by-id', params: {id: 1}}">product 1</router-link>
            <router-link :to="{name: 'product-by-id', params: {id: 2}}">product 2</router-link>
            <router-link :to="{name: 'about'}">à propos</router-link>

            <router-link :to="{name: 'about'}"><button>click me</button></router-link>
            <router-link :to="{name: 'about'}" tag="button">click me</router-link>
            <button @click="$router.push({name: 'home'})">go to homepage</button>
            <router-view></router-view>
        </div>
        `
    })

    const app = new Vue({
        el: "#app",
        router
    })
    </script>
</body>
</html>